#include <iostream>
#include <vector>
using namespace std;
typedef unsigned long long ull;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, q; cin >> n >> q;
    vector<ull> d(n);
    vector<ull> p(n);
    vector<ull> k(q);
    vector<ull> broj_pojedenih(q,0);

    //unos
    for(int i = 0; i < n; i++){
        cin>> d[i] >> p[i]; // dani kad je kupio i koliko je kupio
    }
    for(int j = 0; j < q; j++){
        cin >> k[j]; // dani kada prestaje da jede
    }


    for(int j = 0; j < q; j++){
        ull trenutno_pojedeni = 0;
        for(int i = 0; i < n; i++){
            if(d[i] < k[j]) trenutno_pojedeni += min( k[j] - d[i] + 1,  p[i]); //+1 zato sto jede i na taj dan kada prestane
        }
        broj_pojedenih[j] = trenutno_pojedeni;
    }

    for(int j = 0; j < q; j++){
        cout << broj_pojedenih[j] << endl;
    }

}